/*
 * Segment 5 Intelligente Analyseverfahren, SW-Einheit 5.2 Straßensubsegmentanalyse
 * Copyright (C) 2007-2018 BitCtrl Systems GmbH
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 51
 * Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 *
 * Contact Information:
 * BitCtrl Systems GmbH
 * Weißenfelser Straße 67
 * 04229 Leipzig
 * Phone: +49 341-490670
 * mailto: info@bitctrl.de
 */

package de.bsvrz.iav.subsegana.subsegana.domain.verkehrsdaten;

import java.util.*;

/**
 * Repräsentiert einen Punkt auf einer Linie.
 *
 * @author BitCtrl Systems GmbH, Falko Schumann
 */
public final class Linienreferenz {

    private final Linie linie;
    private final Laenge offset;

    public Linienreferenz(Linie linie, Laenge offset) {
        this.linie = Objects.requireNonNull(linie, "linie");
        this.offset = Objects.requireNonNull(offset, "offset");
    }

    public Linie getLinie() {
        return linie;
    }

    public Laenge getOffset() {
        return offset;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        Linienreferenz that = (Linienreferenz) o;
        return Objects.equals(linie, that.linie) &&
                Objects.equals(offset, that.offset);
    }

    @Override
    public int hashCode() {
        return Objects.hash(linie, offset);
    }

    @Override
    public String toString() {
        return "Linienreferenz{" +
                "linie=" + linie +
                ", offset=" + offset +
                '}';
    }

}
