/*
 * Segment 5 Intelligente Analyseverfahren, SW-Einheit 5.2 Straßensubsegmentanalyse
 * Copyright (C) 2007-2018 BitCtrl Systems GmbH
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 51
 * Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 *
 * Contact Information:
 * BitCtrl Systems GmbH
 * Weißenfelser Straße 67
 * 04229 Leipzig
 * Phone: +49 341-490670
 * mailto: info@bitctrl.de
 */

package de.bsvrz.iav.subsegana.subsegana.domain.verkehrsdaten;

import java.util.*;

/**
 * Repräsentiert den Zustand eines Störfalls.
 *
 * @author BitCtrl Systems GmbH, Falko Schumann
 */
public final class Stoerfallzustand {

    private final Stoerfallsituation situation;
    private final Gueteindex gueteindex;

    public Stoerfallzustand(Stoerfallsituation situation, Gueteindex gueteindex) {
        this.situation = situation;
        this.gueteindex = gueteindex;
    }

    public Stoerfallsituation getSituation() {
        return situation;
    }

    public Gueteindex getGueteindex() {
        return gueteindex;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        Stoerfallzustand that = (Stoerfallzustand) o;
        return situation == that.situation &&
                Objects.equals(gueteindex, that.gueteindex);
    }

    @Override
    public int hashCode() {
        return Objects.hash(situation, gueteindex);
    }

    @Override
    public String toString() {
        return "Stoerfallzustand{" +
                "situation=" + situation +
                ", gueteindex=" + gueteindex +
                '}';
    }

}
